-- phpMyAdmin SQL Dump
-- version 2.11.9.2
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: May 06, 2009 at 05:34 PM
-- Server version: 5.0.67
-- PHP Version: 5.2.6

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Database: `usap-drupal`
--

-- --------------------------------------------------------


--
-- Table structure for table `evaluation_responsibility`
--

CREATE TABLE IF NOT EXISTS `evaluation_responsibility` (
  `Evaluation_Responsibility_ID` int(5) NOT NULL auto_increment,
  `Type` text,
  `Current_ID_FC` text,
  `Current_Name_FC` text,
  `Child_ID_FC` text,
  `Current_Text_FC` text,
  `Rationale_FC` text,
  `Implementation_Details_FC` text,
  PRIMARY KEY  (`Evaluation_Responsibility_ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `evaluation_responsibility`
--

-- --------------------------------------------------------

--
-- Table structure for table `evaluation_results`
--

CREATE TABLE IF NOT EXISTS `evaluation_results` (
  `Results_ID` int(5) NOT NULL auto_increment,
  `Evaluation_Responsibility_ID` int(5) NOT NULL,
  `Usap_Code` text, 
  `Checked_Status` int(5),
  `Discuss_status` int(5),
  `Notes` text,
  PRIMARY KEY  (`Results_ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `evaluation_results`
--

-- --------------------------------------------------------


--
-- Table structure for table `responsibility`
--

CREATE TABLE IF NOT EXISTS `responsibility` (
  `Responsibility_ID` int(5) NOT NULL auto_increment,
  `USAP_ID` int(5) NOT NULL,
  `Current_ID` text NOT NULL,
  `Current_Name` text,
  `Child_ID` text,
  `Current_Text` text,
  `Type` text,
  `Rationale` text,
  `Implementation_Details` text,
  PRIMARY KEY  (`Responsibility_ID`),
    KEY `FK_responsibility` (`USAP_ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=70 ;

--
-- Dumping data for table `responsibility`
--

INSERT INTO `responsibility` (`Responsibility_ID`, `USAP_ID`, `Current_ID`, `Current_Name`, `Child_ID`, `Current_Text`, `Type`, `Rationale`, `Implementation_Details`) VALUES
(1, 1, '1', 'Authorization', '1.1', 'Identification', 'u', '', ''),
(2, 1, '1.1', 'Identification', '1.1.1', 'The system has to provide a way for the USER to input his, her or its identity. (For a human user, this input could be user typing a login ID, running a finger over a fingerprint reader, or standing in front of a camera for face recognition, etc. For a system user, this input could be an IP address, a previously specified identity, etc.)', 'l', 'Software has no way of recognizing a USER without explicit input.\r\nUSERs want to access the system.\r\nThe environment contains multiple potential users only some of whom are allowed to use the system.\r\n\r\n', 'The USERs are involved because they must take explicit action.\r\nThe portion of the system that receives user input is involved, because usersâ€™ explicit action must be handled by the system.\r\nThere must be a portion of the system that processes the input.\r\n\r\n'),
(3, 1, '1.1', 'Identification', '1.1.2', 'The system should inform the USER and/or the system administrator of the results of the identification. Typically, a successful identification is indicated by allowing the USER to proceed. ', 'l', 'USERs want to know if their identification succeeded so they can proceed.\r\nUSERs want to know if their identification failed because they cannot proceed without it.\r\nSystem administrators might want to know of a failed identification because it might be an indication of unauthorized users attempting to access the system.\r\nThe environment contains multiple potential users, some of whom might be malicious.\r\n\r\n', 'In the event of failing to be identified,\r\nThe portion of the system that does the identification must provide information about the failure.\r\nIf informing the system administrator:\r\nIn the event of a failure, a portion of the system must have a mechanism to inform the system administrator. This may be quite complicated (e.g., sending email) and is beyond the scope of this USAP.\r\nFor informing the USER:\r\nIn the event of a failure, the portion of the system that renders information to the user should display information about the failure. Often this feedback will wait for authentication information to be input and the feedback will be of the form that this userID/password are not known to the system. \r\nIn the event of a successful identification, the portion of the system that renders information to the user should indicate success in some way (e.g., simply letting the USER proceed).\r\nThe portion of the system that handles input from the user should provide a UI to dismiss any unwanted information.\r\n\r\n'),
(4, 1, '1.1', 'Identification', '1.1.3', 'The system must remember the USER''s credentials for the duration of the session', 'l', 'The software will use this information later (e.g., in determining authorization).\r\nThe USER only wants to enter this information once per session.\r\nThe environment contains multiple potential users only some of whom are allowed to use the system.\r\n\r\n', 'There must be a portion of the system that maintains the USER''s identity.'),
(5, 1, '1.1', 'Identification', '1.1.4', 'The system must display the identity of the current USER', 'l', 'The USER wants to be sure that the system knows who he or she is', 'The portion of the system that maintains the USER''s identity provides the USER''s identity.\r\nThe portion of the system that renders information to the user displays the USER''s identity.\r\nThe portion of the system that handles input from the user should provide a UI to dismiss any unwanted information.\r\n\r\n'),
(6, 1, '1.1', 'Identification', '1.1.5', 'The system must provide a way for the USER to recover from mistakes in identification. (This could be an erroneous input by the user or the system or it could be the user forgetting his or her user ID. In the case of erroneous input, the solution could be as simple as re-entering the information, so this section will expand on the case of forgetting.)', 'l', 'USERs sometimes forget the way to identify themselves to the system.\r\nSoftware has no way of recognizing a USER without correct explicit input.\r\nThe environment contains multiple potential users only some of whom are allowed to use the system\r\n\r\n', 'The USERs are involved because they must explicitly indicate that they forgot their ID.\r\nThe portion of the system that receives user input is involved, because usersâ€™ explicit action must be handled by the system.\r\nThere must be a portion of the system that has a mechanism to inform the USER of the correct ID. This mechanism may be quite complicated (e.g., sending email to a previously-stored address), and is beyond the scope of this USAP.\r\n\r\n'),
(7, 1, '1', 'Authorization', '1.2', 'Authentication', 'u', '', ''),
(8, 1, '1.2', 'Authentication', '1.2.1', 'The system must provide a way for the USER to input his, her or its authentication. (For a human user, this input could be a user typing a password or running a finger over a fingerprint reader. For a system user, this input could be a certificate or previous authentication).', 'l', 'Software has no way of authenticating a USER without explicit input.\r\nUSERs want to know that they are the only ones able to take action under their names.\r\nThe environment contains multiple potential users only some of whom are allowed to use the system. \r\nThe organization wants to restrict access to authorized USERs and to have USERs be accountable for their actions.\r\n\r\n', 'USERs are involved because they must take eexplicit action. The portion of the system that receives user input is involved because users explicit action must be handled by the system. There must be a portion of the system that processes the input.'),
(9, 1, '1.2', 'Authentication', '1.2.2', 'The system must perform and remember the results of the authentication. (This could be matching a password, recognizing a fingerprint, face recognition, etc. This might be a multi-stage process, e.g., first validating a userâ€™s ID and then matching it to the password.)', 'l', 'The system is the entity that has the information necessary to perform the authentication.', 'The portion of the system that maintains the USERâ€™s identity provides the USERâ€™s identity.\r\nThere must be a portion of the system that performs the authentication.\r\nThe portion of the system that maintains the USERâ€™s identity must remember whether this USER has been authenticated.\r\n\r\n'),
(10, 1, '1.2', 'Authentication', '1.2.3', 'The system should inform the USER and/or the system administrator of the results of the authentication. ', 'l', 'USERs want to know if their authentication succeeded so they can proceed.\r\nUSERs want to know if their authentication failed because they cannot proceed without it.\r\nSystem administrators might want to know of a successful authentication for audit trail purposes.\r\nSystem administrators might want to know of a failed authentication because it might be an indication of unauthorized users attempting to access the system.\r\nThe environment contains multiple potential users, some of whom might be malicious.\r\n\r\n', 'In the event of failing to be authenticated,\r\nThe portion of the system that does the authentication must provide information about the failure.\r\nIf informing the system administrator:\r\nIn any event, a portion of the system must have a mechanism to inform the system administrator. This may be quite complicated (e.g., sending email) and is beyond the scope of this USAP.\r\nFor informing the USER:\r\nIn the event of a failure, the portion of the system that renders information to the user should display information about the failure.\r\nIn the event of a successful authentication, the portion of the system that renders information to the user should indicate success in some way (e.g., a welcome message or simply letting the user proceed).\r\nThe portion of the system that handles input from the user should provide a UI to dismiss any unwanted information.\r\n\r\n'),
(11, 1, '1', 'Authorization', '1.3', 'Permissions', 'u', '', ''),
(12, 1, '1.3', 'Permissions', '1.3.1', 'The system must permit or prohibit specific authoring or execution of ACTIVITIES dependent on who the USER is and on the set of authoring or execution of ACTIVITIES they are attempting to perform, i.e., the system must know (built in, stored, provided by the OS, etc.) the specific permissions for each USER and then enforce these permissions', 'l', 'The organization may wish to allow different USERs to have different capabilities.\r\nThe USERs want access to the authoring or execution of ACTIVITIES they have permission for.\r\nThe system has to have a concept of permissions to be able to allow or disallow authoring or execution of ACTIVITIES.\r\nThe system has to know the mapping between USERs and authoring or execution of ACTIVITIES to grant different permissions to different users.\r\n\r\n', 'The portion of the system that maintains the USERâ€™s authenticated identity provides the USERâ€™s identity.\r\nThe portion of the system that does the authoring or execution of ACTIVITIES must provide the requested authoring or execution of ACTIVITIES.\r\nThere must be a portion of the system that maintains the mapping between USERs and their permitted authoring or execution of ACTIVITIES.\r\nThis latter portion of the system must use the USERâ€™s authenticated identity, the particular authoring or execution of ACTIVITIES desired and the map to determine whether the authoring or execution of ACTIVITIES are allowed.\r\n\r\n'),
(13, 1, '1.3', 'Permissions', '1.3.2', 'The USER and/or the system administrator should be informed when permission is granted or denied for doing ACTIVITIES. Typically, this is done through the portion of the system that requests the ACTIVITIES.', 'l', 'USERs want to know if their operations failed because of permission.\r\nSystem administrators might want to know if permission is denied because it might be an indication of users attempting to exceed their permissions.\r\nThe environment contains multiple potential users, some of whom might be malicious.\r\n\r\n', 'In the event of failing to be allowed to do ACTIVITIES,\r\nThe portion of the system that does the ACTIVITIES must provide information about the failure.\r\nIf informing the system administrator:\r\nA portion of the system must have a mechanism to inform the system administrator. This may be quite complicated (e.g., sending email) and is beyond the scope of this USAP.\r\nFor informing the USER:\r\nIn the event of a failure, the portion of the system that renders information to the user should display information about the failure.\r\nIn the event of a successful permission, the portion of the system that does the ACTIVITIES should proceed and inform the USER appropriately, typically through the results of performing the ACTIVITIES.\r\nThe portion of the system that handles input from the user should provide a UI to dismiss any unwanted information.\r\n\r\n'),
(14, 1, '1', 'Authorization', '1.4', 'Log off', 'u', '', ''),
(15, 1, '1.4', 'Log off', '1.4.1', 'The system must have a way for the USER to log off. (If there are requests still pending (e.g., unsaved changes), then notify the user and ask for confirmation of the log-off request. Consider some way to protect the system if the confirmation if not forthcoming in a reasonable amount of time.)', 'l', 'Software has no way of knowing that a USER is finished without explicit input.\r\nUSERs wants to protect their work.\r\nThe environment contains multiple potential users, some of whom may be malicious, so logging off prevents them from having access.\r\n\r\n', 'If log-off is at the USER''s request:\r\nThe system must provide a means for the USER to indicate a desire to log-off (e.g., a button, keyboard shortcut, voice command).\r\nThe USER must indicate their desire to log off and respond to any confirmation request.\r\nThe portions of the system that do the ACTIVITIES must ask for confirmation in the event of request still pending. This involves keeping track of pending requests and requesting the appropriate interactions with the USER.\r\nThere must be a portion of the system that de-authenticates the USER after receiving the log-off request and any necessary confirmations.\r\nIf with a system-initiated request:\r\nThere must be a portion of the system with a mechanism to initiate a log-off request. (This may be as simple as a time-out or quite complicated (e.g., shutting down the entire system), and is beyond the scope of this USAP.)\r\nIf there are pending requests, waiting for the USER to confirm is not a good idea, either the requests are aborted or the log-off is aborted.\r\n\r\n'),
(16, 2, '2', 'Authoring', '2.1', 'Create a SPECIFICATION', 'u', '', ''),
(17, 2, '2.1', 'Create a SPECIFICATION', '2.1.1', 'The system must provide a way for an authorized author to create a SPECIFICATION.', 'l', 'A SPECIFICATION doesn''t exist unless it is created.', 'The portion of the system that renders output must render a UI that allows the parameters to be specified and displays existing values.\r\nThe portion of the system that accepts input from the user must accept parameters.\r\nThere must be a portion of the system with a mechanism to create new SPECIFICATIONs.\r\n\r\n'),
(18, 2, '2.1', 'Create a SPECIFICATION', '2.1.2', 'Consider providing default values for all specifiable parameters when a SPECIFICATION is created. (Providing defaults simplifies the creation process, but may increase the probability of error for environments that deviate from those defaults. If the cost of error is high, then consider not providing defaults or requiring confirmation of each value. Default values can be changed through modification.)', 'l', 'System has to have something so defaults might be provided.\r\nCircumstances might be very similar so defaults might capture that similarity.\r\nAuthors may want to be efficient and defaults may save authoring time.\r\nAuthors may only be interested in changing specific aspects of the SPECIFICATION, so having defaults for the rest of it is useful.\r\n\r\n', 'The portion of the system that creates a new SPECIFICATION must assign defaults.'),
(19, 2, '2.1', 'Create a SPECIFICATION', '2.1.3', 'The SPECIFICATION must be given an identifier. The identifier should be treated as a parameter that has a default value and can be modified by the user. (One mechanism for assigning this identification might be a â€œSave asâ€.)', 'l', 'Circumstances might be very similar so values in one SPECIFICATION may transfer to other circumstances.\r\nAuthors may want to be efficient and may want to begin the specification process with a similar SPECIFICATION.\r\nThe authoring system must have an identifier to distinguish one SPECIFICATION from another.\r\n\r\n', 'If the identifier is provided by a author:\r\nThe portion of the system that renders output must render a UI that allows the author to provide an identifier and display it.\r\nThe portion of the system that accepts input from the user must accept the identifier.\r\nThere must be a portion of the system that manages the authoring process. \r\nThe portion of the system that manages the authoring process must associate the SPECIFICATION with the identifier.\r\nIf the identifier is provided automatically by the system:\r\nThe portion of the system that creates the SPECIFICATION generates an identifier (e.g., MSWord automatically generates a name for a new document). \r\nThe portion of the system that manages the authoring process must associate the SPECIFICATION with the identifier.\r\n\r\n'),
(20, 2, '2.1', 'Create a SPECIFICATION', '2.1.4', 'The SPECIFICATION must be associated with the APPROPRIATENESS-INFORMATION (i.e., the circumstances under which it should be invoked (e.g., for specific users, roles, environments)). The APPROPRIATENESS-INFORMATION should be treated as a parameter that has a default value and can be modified by the author.', 'l', 'The SPECIFICATION is only appropriate for use under certain circumstances.\r\nSystem can only use a SPECIFICATION if it is associated with a circumstance.\r\nUsers want the system to work for them the way they want it to work when they want it to work that way.\r\n\r\n', 'If the association is provided by an author:\r\nThe portion of the system that renders output must render a UI that allows the authoring of APPROPRIATENESS-INFORMATION and display existing values.\r\nThe portion of the system that accepts input from the user must accept the APPROPRIATENESS-INFORMATION.\r\nThe portion of the system that manages the authoring process must associate the SPECIFICATION with the APPROPRIATENESS-INFORMATION.\r\nIf the association is provided automatically by the system when a new user or role is created:\r\nThe portion of the system that creates the SPECIFICATION generates an association. \r\nThe portion of the system that manages the authoring process associates the SPECIFICATION with the circumstances.\r\n\r\n'),
(21, 2, '2', 'Authoring', '2.2', 'Save a SPECIFICATION', 'u', '', ''),
(22, 2, '2.2', 'Save a SPECIFICATION', '2.2.1', 'The system must provide a means for an authorized author to save and/or export the SPECIFICATION (e.g., by autosave or by author request).If other systems are going to use the SPECIFICATION, then use a format that can be used by the other systems. ', 'l', 'Authors want to be efficient (i.e., input information into the SPECIFICATION only once).\r\nThe system can only remember things if they are persistent from session to session.\r\nThe software may need to share a SPECIFICATION with other software.\r\n\r\n', 'If the initiation of the save was automatic:\r\nThat portion of the system that manages the authoring process performs the initiation.\r\nThat portion of the system that manages the authoring process stores and/or exports the SPECIFICATION.\r\nIf the initiation of the save was at the authorâ€™s request:\r\nThe portion of the system that renders output must render a UI that allows the parameters needed by the system (e.g., format, location) to be input and display them.\r\nThe portion of the system that accepts input from the user must accept the parameters.\r\nThat portion of the system that manages the authoring process stores and/or exports the SPECIFICATION.\r\n\r\n'),
(23, 2, '2', 'Authoring', '2.3', 'Modify a SPECIFICATION', 'u', '', ''),
(24, 2, '2.3', 'Modify a SPECIFICATION', '2.3.1', 'Provide a way for an authorized author to retrieve a SPECIFICATION (e.g., import a previously-saved file, utilize a previously-generated data structure, or restore to default values). ', 'l', 'Authors might want different values than are currently assigned.\r\nSystem has stored the information and must have a current set of data to work with.\r\n\r\n', 'The portion of the system that renders output must render a UI that allows the author to request a retrieval of a SPECIFICATION.\r\nThe portion of the system that accepts input from the user must accept this request.\r\nThat portion of the system that manages the authoring process retrieves the SPECIFICATION.\r\n\r\n'),
(25, 2, '2.3', 'Modify a SPECIFICATION', '2.3.2', 'Display the current parameter values (including identifier and circumstances)', 'l', 'Authors want to see what they are editing.', 'That portion of the system that manages the authoring process must provide the values.\r\nThe portion of the system that renders output must render a UI that displays the values.\r\nThe portion of the system that handles input from the user should provide a UI to dismiss any unwanted information.\r\n\r\n'),
(26, 2, '2.3', 'Modify a SPECIFICATION', '2.3.3', 'The system must provide a ways for an authorized author to change the parameter values. The syntax and semantics of the values specified should conform to the assumptions of the execution environment of the system. (More details: Best practice is to constrain the author to such conformation (e.g., choose from drop-down list, provide a slider for a range of values). If the author''s choices are not constrained, then the system should check the syntax and semantics and provide feedback if either are unreasonable.) ', 'l', 'Authors might want different values than are currently assigned.', 'The portion of the system that renders output must render a UI that allows values to be changed.\r\nThe portion of the system that accepts input from the user must accept new values.\r\nThat portion of the system that manages the authroing process replaces the current values with the new values.\r\n\r\n'),
(27, 2, '2', 'Authoring', '2.4', 'Delete a SPECIFICATION', 'u', '', ''),
(28, 2, '2.4', 'Delete a SPECIFICATION', '2.4.1', 'Provide a way for an authorized author to tentatively remove a SPECIFICATION from the system (e.g., analogous to dragging a file to the trash). The system might require a confirmation from the author prior to performing this action. ', 'l', 'Authors might accidentally delete a SPECIFICATION and want to restore it.\r\nThe organization doesnâ€™t want extraneous SPECIFICATIONs on the system.\r\nThe system has to keep it around in case it has to be restored.\r\n\r\n', 'The portion of the system that renders output must render a UI that allows the author to tentatively delete a SPECIFICATION. \r\nThe portion of the system that accepts input from the user must accept this request.\r\nThat portion of the system that manages the authoring process saves the SPECIFICATION in case has to be restored.\r\nThe portion of the system that renders output must indicate that the SPECIFICATION has been (tentatively) deleted. \r\n\r\n'),
(29, 2, '2.4', 'Delete a SPECIFICATION', '2.4.2', 'Retrieve a tentatively-deleted SPECIFICATION from the system (e.g., analogous to dragging a file out of the trash)', 'l', 'Authors might want to restore an accidentally deleted SPECIFICATION.\r\nThe system has kept it around so that it can be restored.\r\n\r\n', 'The portion of the system that renders output must render a UI that allows the author to restore a tentatively deleted SPECIFICATION. \r\nThe portion of the system that accepts input from the user must accept this request.\r\nThat portion of the system that manages the authoring process must restore the SPECIFICATION.\r\nThe portion of the system that renders output must indicate that the SPECIFICATION has been restored. \r\n\r\n'),
(30, 2, '2.4', 'Delete a SPECIFICATION', '2.4.3', 'Provide a way for an authorized author to permanently remove a SPECIFICATION from the system (e.g., analogous to emptying the trash). The system should require a confirmation from the author prior to performing this action. ', 'l', 'Authors want to delete a SPECIFICATION that is no longer relevant to their needs.\r\nThe organization doesnâ€™t want extraneous SPECIFICATIONs on the system.\r\nThe system has limited resources.\r\n\r\n', 'The portion of the system that renders output must render a UI that allows the author to permanently delete a SPECIFICATION. \r\nThe portion of the system that accepts input from the user must accept this request.\r\nThat portion of the system that manages the authoring process permanently deletes the SPECIFICATION.\r\nThe portion of the system that renders output must indicate that the SPECIFICATION has been deleted. \r\n\r\n'),
(31, 2, '2', 'Authoring', '2.5', 'Exit a SPECIFICATION', 'u', '', ''),
(32, 2, '2.5', 'Exit a SPECIFICATION', '2.5.1', 'The system must have a way for the author to exit the authoring system. (If there are requests still pending (e.g., unsaved changes), then notify the author and ask for confirmation of the exit request.)', 'l', 'Software has no way of knowing that an author is finished without explicit input.\r\nAuthors want to exit when they are done.\r\n\r\n', 'The system must provide a means for the author to indicate a desire to exit (e.g., a button, keyboard shortcut, voice command).\r\nThe authors must indicate their desire to exit and respond to any confirmation request.\r\nThe portions of the system that do the authoring activities must ask for confirmation in the event of request still pending. This involves keeping track of pending requests and requesting the appropriate interactions with the author.\r\n\r\n'),
(33, 3, '3', 'Execution with Authored Parameters', '3.1', 'Access the appropriate SPECIFICATION', 'u', '', ''),
(34, 3, '3.1', 'Access the appropriate SPECIFICATION', '3.1.1', 'Retrieve APPROPRIATENESS-INFORMATION (which will allow determination of appropriate SPECIFICATION). ', 'l', 'The system needs a SPECIFICATION in order to execute appropriately.\r\nSystem has no way to determine appropriateness of a SPECIFICATION without APPROPRIATENESS-INFORMATION. Sometimes this information may have to come from a user, sometimes it can be inferred from the environment.\r\nUsers and organizations want the system to execute appropriately.\r\n\r\n\r\n', 'There must be a portion of the system that knows how to retrieve APPROPRIATENESS-INFORMATION. For example, APPROPRIATENESS-INFORMATION may be maintained in a fixed location within a system or within the file structure of the system.'),
(35, 3, '3.1', 'Access the appropriate SPECIFICATION', '3.1.2', 'The system must retrieve the appropriate SPECIFICATION', 'l', 'The system needs a SPECIFICATION in order to execute appropriately.\r\nUsers and organizations want the system to execute appropriately.\r\n\r\n', 'The portion of the system that will use the specified parameters must retrieve the SPECIFICATION.'),
(36, 3, '3.1', 'Access the appropriate SPECIFICATION', '3.1.3', 'The system should inform the user and/or the system administrator of the results of attempting to retrieve the appropriate SPECIFICATION. There are three cases: find zero, find one, find many. (Typically, finding zero generates an error message, finding one is indicated by allowing the user to proceed, finding many is indicated by listing their identifiers and allowing the user to view the contents of the SPECIFICATION.)', 'l', 'Users want to know if the appropriate SPECIFICATION has been located so they can proceed.\r\nUsers want to know if the appropriate SPECIFICATION has not been located because they cannot proceed without it.\r\nUsers want to know if more than one appropriate SPECIFICATION has been located because they can help resolve the ambiguity.\r\nSystem administrators might want to know if the appropriate SPECIFICATION has not been located or if there are many, because it might be an indication of system error.\r\n\r\n', 'In the event of failing to be located or finding more than one appropriate SPECIFICATION:\r\nThe portion of the system that does the locating must provide information about the failure or the identities of each SPECIFICATION.\r\nIf informing the system administrator:\r\nIn the event of a failure or locating more than one appropriate SPECIFICATION, a portion of the system must have a mechanism to inform the system administrator. This may be quite complicated (e.g., sending email) and is beyond the scope of this USAP.\r\nFor informing the user:\r\nIn the event of a failure:\r\nThe portion of the system that renders information to the user should display information about the failure.\r\nIn the event of a successfully locating an appropriate SPECIFICATION:\r\nThe portion of the system that renders information to the user displays should indicate success in some way (e.g., progress feedback saying it is retrieving the SPECIFICATION).\r\nIn the event of finding many:\r\nThe portion of the system that renders information to the user should indicate the identifier of each SPECIFICATION.\r\nThe portion of the system that renders information to the user should provide a UI for allowing the user to resolve the ambiguity.\r\nThe portion of the system that handles input from the user should allow the user to select one of the located SPECIFICATIONs or request to view the contents of one or more of the located SPECIFICATIONs.\r\nThe portion of the system that handles input from the user should provide a UI to dismiss any unwanted information.\r\n\r\n'),
(37, 3, '3.1', 'Access the appropriate SPECIFICATION', '3.1.4', 'The system must check that the retrieved SPECIFICATION is valid for use.', 'l', 'System cannot use an invalid SPECIFICATION', 'The portion of the system that will use the specified parameters must check the SPECIFICATION to make sure it is valid (e.g., it could be empty, corrupt, or incomplete).'),
(38, 3, '3.1', 'Access the appropriate SPECIFICATION', '3.1.5', 'The system should inform the user and/or the system administrator of the results of validating the SPECIFICATION', 'l', 'Users want to know if the SPECIFICATION is valid so they can proceed.\r\nUsers want to know if the SPECIFICATION is not valid because they cannot proceed with an invalid SPECIFICATION.\r\nSystem administrators might want to know if the SPECIFICATION is not valid, because it might be an indication of system error.\r\n\r\n', 'In the event of an invalid SPECIFICATION:\r\nThe portion of the system that does the validation must provide information about the failure.\r\nIf informing the system administrator:\r\nIn the event of a failure, a portion of the system must have a mechanism to inform the system administrator. This may be quite complicated (e.g., sending email) and is beyond the scope of this USAP.\r\nFor informing the user:\r\nIn the event of an invalid SPECIFICATION:\r\nThe portion of the system that renders information to the user should display information about the failure.\r\nIn the event of a valid SPECIFICATION:\r\nThe portion of the system that renders information to the user displays should indicate success in some way. This is typically indicated by allowing the user to proceed.\r\nThe portion of the system that handles input from the user should provide a UI to dismiss any unwanted information.\r\n\r\n'),
(39, 3, '3.1', 'Access the appropriate SPECIFICATION', '3.1.6', 'In the event of a missing, invalid or partially invalid SPECIFICATION, the system should provide the user with options for exiting the system or fixing the problem e.g., offering defaults for values or offering to direct the user to the authoring interface', 'l', 'Even though the portion of the system that creates a new SPECIFICATION provides defaults, a SPECIFICATION might have been corrupted.\r\nA system cannot work without a valid SPECIFICATION.\r\nThe user wants to use the system, so if the system canâ€™t be used for lack of a valid SPECIFICATION then the user wants to fix it.\r\n\r\n', 'The portion of the system that renders information to the user should display information about the options.\r\nThe portion of the system that handles input from the user should allow the user to select one of the options.\r\nThe portion of the system that validates the SPECIFICATION should generate defaults for unspecified or invalid parameters. These defaults should be consistent with the defaults generated by the portion of the system that creates a new SPECIFICATION.\r\nThe portion of the system that validates the SPECIFICATION should act on the option selected by the user.\r\n\r\n'),
(40, 3, '3.1', 'Access the appropriate SPECIFICATION', '3.1.7', 'The system must provide a means for displaying and dismissing the content of a SPECIFICATION. (This is so they can decide between multiple SPECIFICATIONs or check that the current SPECIFICATION has correct values.) Optionally, when displaying, the system could offer the user access to the authoring interface to modify parameter values. ', 'l', 'Users might want to check the parameter values in the SPECIFICATION.\r\nUsers might want to modify the parameter values in the SPECIFICATION.\r\n\r\n', 'The portion of the system that retrieves the SPECIFICATION must provide the parameters and their values.\r\nThe portion of the system that renders information to the user should display the parameters and their values.\r\nThe portion of the system that handles input from the user should provide a UI to request the display and dismiss any unwanted information.\r\nOptional connection to the authoring system for users with authoring permission:\r\nThe portion of the system that handles input from the user should provide a UI to invoke the authoring system (with parameter SPECIFICATION).\r\nThe portion of the system that retrieves the SPECIFICATION should invoke the authoring system (with parameter SPECIFICATION).\r\n\r\n'),
(41, 3, '3', 'Execution with Authored Parameters', '3.2', 'Use specified parameters', 'u', '', ''),
(42, 3, '3.2', 'Use specified parameters', '3.2.1', 'The system must apply the specified parameters as necessary for execution. That is, the items specified must be treated as parameters by the system code (i.e., not hard-coded anywhere) and the values must be taken from the SPECIFICATION', 'l', 'The entire point of this foundational USAP is that users want to control the behavior of the computer in certain ways under certain circumstances that they have previously specified. Therefore, the system must use the specified parameters.', 'There must be a portion of the system where the parameters that have been specified have some effect.\r\nThis portion of the system must treat the parameters as variables rather than as hard-coded values. It must assign the specified parameter values to these variables.\r\n\r\n'),
(43, 3, '3.2', 'Use specified parameters', '3.2.2', 'The system must provide a UI to accept operator inputs as necessary', 'l', 'Some of the actions of the SPECIFICATION may require operator input.', 'The portion of the system that renders information to the user should display the request/opportunity for operator input.\r\nThe portion of the system that handles input from the user should provide a UI to provide operator input.\r\nThere must be a portion of the system that receives and interprets operator input.\r\n\r\n'),
(44, 4, '4', 'Logging', '4.1', 'Specify the items to be logged. ', 'u', '', ''),
(45, 4, '4.1', 'Specify the items to be logged. ', '4.1.1', 'Ensure that sufficient parameters are specified so that subsequent analysis is meaningful (e.g., CONTEXT, parameter name, and time stamp). Consider prototyping and testing log information and analysis to ensure sufficiency ', 'l', 'Software must know the information to be logged.\r\nThe values in the repository are going to be examined at a later time and these values must be able to be uniquely identified with sufficient information to be useful.\r\n\r\n', 'If done during development:\r\nImplementation is beyond the scope of this USAP.\r\nIf done during or after deployment:\r\nUse the Authoring Foundational USAP with parameter SPECIFICATION=Logging specification.\r\n\r\n'),
(46, 4, '4', 'Logging', '4.2', 'Log items during execution', 'u', '', ''),
(47, 4, '4.2', 'Log items during execution', '4.2.1', 'Have a repository in which to store logged items. This repository could be bounded in size, e.g., circular buffer, or unbounded, e.g., disk file. ', 'l', 'The system must have a place to put logged information.', 'There must be a portion of the system that logs information.\r\nThe portion of the system that logs information must know the form of the repository and its location and may be responsible for creating the repository.\r\n\r\n'),
(48, 4, '4.2', 'Log items during execution', '4.2.2', 'Enter values into the repository as specified. ', 'l', 'Users need the logged values for debugging or audit trail purposes.\r\nStored information must persist long enough for analysis to be undertaken.\r\n\r\n', 'The portion of the system that logs information enters the particular values into the repository. \r\nAttention should be paid to performance considerations since this code may be executed many time.\r\n\r\n'),
(49, 4, '4', 'Logging', '4.3', 'Post-processing', 'u', '', ''),
(50, 4, '4.3', 'Post-processing', '4.3.1', 'Retrieve items from the repository. This is typically done some time after the information has been logged, e.g., during the analysis of an anomaly.', 'l', 'Users need information to analyze past events.\r\nThe information they need has been stored in the repository and must be retrieved.\r\n\r\n', 'There must be a portion of the system that knows how to get information out of the repository and does so.'),
(51, 4, '4.3', 'Post-processing', '4.3.2', 'Support analysis of retrieved items by a log analyst (a special type of user)', 'l', 'Users need support to analyze past events.', 'This may be quite complicated (e.g., graphical display, manipulation, mathematical modeling, debugging) and is beyond the scope of this USAP.'),
(52, 5, '5', 'Environment Configuration', '5.1', 'Author Configuration Description', 'u', '', ''),
(53, 5, '5.1', 'Author Configuration Description ', '5.1.1', 'None', 'l', '', ''),
(55, 5, '5.2', 'Execute with Authored Configuration Description', '5.2.1', 'None', 'c', '', ''),
(54, 5, '5', 'Environment Configuration', '5.2', 'Execute with Authored Configuration Description', 'u', '', ''),
(56, 6, '6', 'User Profile', '6.1', 'Author User Profile', 'u', '', ''),
(57, 6, '6.1', 'Author User Profile', '6.1.1', 'None', 'l', '', ''),
(58, 6, '6', 'User Profile', '6.2', 'Execute with Authored User Profile', 'u', '', ''),
(59, 6, '6.2', 'Execute with Authored User Profile', '6.2.1', 'None', 'l', '', ''),
(60, 7, '7', 'Alarms and Events', '7.1', 'Author Rules for Alarms, Events and Displays ', 'u', '', ''),
(61, 7, '7.1', 'Author Rules for Alarms, Events and Displays ', '7.1.1', 'None', 'l', '', ''),
(62, 7, '7', 'Alarms and Events', '7.2', 'Execute with Authored Rules for Alarms, Events and Displays', 'u', '', ''),
(63, 7, '7.2', 'Execute with Authored Rules for Alarms, Events and Displays', '7.2.1', 'The system must permit multiple users to operate simultaneously in accordance with the protocol defined in the assumptions, e.g., each user could have the ability to have their own display filter settings.', 'l', 'Some large systems may require more than one operator to function safely.\r\nEach operator may want to sort the alarm list display according to different criteria depending on his/hers current task or preferences.\r\n\r\n', 'The portion of the system that stores system data must be shareable among multiple users.\r\nThe portion of the system that manages system data must synchronize among multiple users to avoid simultaneous update of system data.\r\nThe portion of the system that manages system data must implement a protocol that determines what the system must do in the event that two users simultaneously issue conflicting commands. Consider informing the users in the event of a conflict as a portion of the protocol.\r\nThe portion of the system that manages user-specific data must be thread safe (e.g., re-entrant)\r\nThe portion of the system that interacts with the users must be thread safe.\r\n\r\n'),
(64, 7, '7.2', 'Execute with Authored Rules for Alarms, Events and Displays', '7.2.2', 'The system must have the ability to translate the names/ids of externally generated signals, e.g., from a sensor, into the concepts that are included in the Alarms&Events specification.', 'l', 'The environment contains sensors that generate and actuators that respond to analog or digital signals in their own form.\r\nThe alarm and event portion of the system can only operate with logical concepts.\r\n\r\n', 'There should be a portion of the system (e.g., an intermediary) that sits between those portions of the system that interact directly with sensors and actuators (e.g., the device drivers) and the portion of the system that implements the alarm and event logic.\r\nThis intermediary should translate between the signals by the sensors and actuators and the logical concepts required by alarm and event rules.\r\n\r\n'),
(65, 7, '7.2', 'Execute with Authored Rules for Alarms, Events and Displays', '7.2.3', 'The system must have the ability to broadcast a generated event so that an external system can use it. E.g. an external long-time storage system.', 'l', 'Some events require informing external people or systems. For example, an explosion may need to call emergency responders.', 'The portion of the system that executes the alarm and event rules must have the capability to broadcast to appropriate external systems. '),
(66, 7, '7.2', 'Execute with Authored Rules for Alarms, Events and Displays', '7.2.4', 'The system must have the ability to present alarm state transitions in the alarm displays within the time restrictions valid for this system.', 'l', 'Users have limits as to how fast they can operate, i.e., perceive information, comprehend information, make decisions, and perform motor actions. This imposes a lower bound on how long information has to be displayed (visual or auditory).\r\nBecause the alarm system may supervise hazardous environments, safety regulations may require specific response times. This imposes an upper bound on the number of human actions that can be required to respond to alarms.\r\nAny claims made for the operator action in response to alarms should be based upon sound human performance data and principles.\r\n\r\n', 'The portion of the system that displays information to the user should ensure that information is displayed long enough for a person to see or hear it. This requires that this portion of the system maintain timing information of how long information has been displayed and ensure that it is longer than minimal human perceptual limits.\r\nThe portion of the system that does the scheduling should schedule alarms as high-priority activities.\r\nThe portion of the system that interacts with the user during emergency situations must be designed to meet the response time requirements. This is the responsibility of the UI designers and does not impose additional architectural requirements.\r\n\r\n'),
(67, 7, '7.2', 'Execute with Authored Rules for Alarms, Events and Displays', '7.2.5', 'The system must have sufficient persistent storage for alarms, rules and data to be saved. It may be acceptable to limit the number of events to be saved.', 'l', 'Regulations might require long-term storage of alarms, rules and data (e.g. in the food and drug business).\r\nAn organization may have publication, notification, history, fault diagnostic needs that require persistent data.\r\nThe system may be stopped and started again and the rules and data must not get lost when this happens.\r\nThere might be a lot of data.\r\nStorage media has cost (hardware, time to read and write, network bandwidth).\r\n\r\n', 'The portion of the system that manages persistent data must ensure that the most recent and the most important data is not lost. This could be done by having large persistent data stores; it could be done by overwriting older data with newer data.\r\nThe portion of the system that manages persistent data must have a protocol to determine which data gets overwritten when persistent storage is almost full.\r\n\r\n');

-- --------------------------------------------------------

--
-- Table structure for table `usap`
--

CREATE TABLE IF NOT EXISTS `usap` (
  `USAP_ID` int(5) NOT NULL auto_increment,
  `USAP_Name` text NOT NULL,
  `Author_ID` int(5) NOT NULL,
  `Type` text NOT NULL,
  `Purpose` text,
  `Glossary` text,
  `Justification` text,
  `Scenario` text,
  `Overview` text,
  `Assumption` text,
  `Shared_Assumption` text,
  `Usability_Benefits` text,
  PRIMARY KEY  (`USAP_ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=8 ;

--
-- Dumping data for table `usap`
--

INSERT INTO `usap` (`USAP_ID`, `USAP_Name`, `Author_ID`, `Type`, `Purpose`, `Glossary`, `Justification`, `Scenario`, `Overview`, `Assumption`, `Shared_Assumption`, `Usability_Benefits`) VALUES
(1, 'Authorization', 0, 'f', 'The Authorization Foundational USAPs purpose is to identify and authenticate users (human or other systems) of the system.', 'To be completed after user testing', 'Users must be authorized when security or personalization is important. ', NULL, NULL, NULL, '', NULL),
(2, 'Authoring', 0, 'f', 'The Authoring Foundational USAP''s purpose is to allow specification of the behavior of the system in certain ways under certain circumstances.', 'To be completed after user testing', 'Users want to control the behavior of the system in certain ways under certain circumstances without having to set it up every time. The system needs a specification of parameters to determine its behavior in these circumstances. Therefore the user must author a specification of parameters that will subsequently be used upon execution (see Foundational USAP Execution with Authored Parameters).', NULL, NULL, NULL, 'Shared with any other USAP that uses the SPECIFICATION:\r\nThe syntax and semantics for the concepts that are included in the SPECIFICATION are defined and known to the developers of both the authoring system and the systems informed by other USAPs that share the SPECIFICATION.\r\nThe protocol for saving the SPECIFICATION is defined and known to the developers of both the authoring system and the systems informed by other USAPs that share the SPECIFICATION.\r\nUSAPs sharing these assumptions:	Execution with Authored Parameters foundational USAP\r\n\r\n', NULL),
(3, 'Execution with Authored Parameters', 0, 'f', 'The Execution with Authored Parameters USAP''s purpose is to allow a system to use a specification of parameters to determine its behavior in the areas in which the parameters apply.', 'To be completed after user testing', 'Users want to control the behavior of the computer in certain ways under certain circumstances that they have previously specified (see the Authoring foundational USAP).', NULL, NULL, NULL, 'Shared with any other USAP that uses the SPECIFICATION:\r\nThe syntax and semantics for the concepts that are included in the SPECIFICATION are defined and known to the developers of both the authoring system and the systems informed by other USAPs that share the SPECIFICATION.\r\nThe protocol for saving is defined and known to the developers of both the authoring system and the systems informed by the Execution with Authored Parameters USAP.\r\nUSAPs sharing this assumption:Authoring Foundational USAP\r\n\r\n', NULL),
(4, 'Logging', 0, 'f', 'The Logging foundational USAP''s purpose is to retain and examine selected information generated during execution.', 'To be completed after user testing', 'Some information known only during execution needs to be retained either for debugging or audit-trail purposes', NULL, NULL, NULL, '', NULL),
(5, 'Environment Configuration', 0, 'e', NULL, 'To be completed after user testing', NULL, 'An organization wants to supply the same software system to different hardware environments containing different collections of sensors and actuators. A configuration description of the sensors and actuators will allow the system to operate correctly in its environment', 'For a software system to be configurable for different environments, actions of the system must be parameterized and the parameter values have to be available at execution time. The values of the parameters must be specified, this configuration description has to be associated with its environment, and the configuration description has to be persistent across sessions.', 'There is at least one user who is authorized to author configuration descriptions.\r\nThe syntax and semantics for the concepts that are included in the configuration description are defined and known to the development team.\r\nThe protocol for saving the configuration description is defined and known to the development team.\r\nDefaults exist for the specifiable parameters.\r\nA template exists for authors to use when creating a new configuration description (i.e., the names and definitions of specifiable parameters and their defaults, with optional format).\r\n\r\n', NULL, 'Environment configuration prevents mistakes by tailoring the interface to present only information relevant to the current environment.'),
(6, 'User Profile', 0, 'e', NULL, 'To be completed after user testing', NULL, 'A user wishes to have the capabilities of the system personalized to reflect his or her preferences or role. The capabilities that can be personalized may include language, access to system functionality, display characteristics, account information or any preference that might vary among users or roles.', 'For a user profile to work, configurable actions of the system must be parameterized and the parameter values have to be available at execution time. The values of the parameters must be specified, this specification (the ''user profile'') has to be associated with the user and persist across sessions.', 'There is at least one user who is authorized to author user profiles.\r\nThe syntax and semantics for the concepts that are included in the User Profile are defined and known to the development team..\r\nThe protocol for saving the User Profile is defined and known to the development team.\r\nDefaults exist for the specifiable parameters.\r\nA template exists for authors to use when creating a new user profile (i.e., the names and definitions of specifiable parameters and their defaults, with optional format).\r\n\r\n', NULL, 'User profile accelerates error-free portion of routine performance by providing information in a familiar and individually-tailored form, providing user-defined hot-keys and allowing common operations to be easily accessible.\r\nUser profile prevents mistakes by simplifying the interface to that which is familiar and necessary. This prevents infrequent users from making the types of mistakes caused by too many options.\r\nUser profile accommodates mistakes by enabling the user to disallow certain options (e.g., disabling the tap-to-click option on a track pad).\r\nUser profile increases user confidence and comfort by providing an individualized interface.\r\n\r\n'),
(7, 'Alarms and Events', 0, 'e', NULL, 'The following definitions are used in this document. <insert Piaâ€™s table)', NULL, 'The user needs feedback from the system when an error occurred or a specific condition is met. The user can be the operator of the system or a superior system. The feedback can be needed for safety reasons, diagnostic, problem solving or information purposes.', 'Alarm, Events and Messages Management System\r\nEEMUA describes how Alarm & Events are important in the control of plant and machinery. Alarm and Event systems form an essential part of the operator interfaces in large modern industrial systems. They provide vital support to the operators managing these complex systems by warning them of situations that need their attention.\r\nAlarms are signals which are annunciated to the operator typically by an audible sound, some sort of visual indication, usually flashing, and by the presentation of a message or some other identifier. An alarm will indicate a problem requiring operator attention, and is generally initiated by a process measurement passing a defined alarm setting as it approaches an undesirable or potentially unsafe value. Alarm systems help the operator;\r\nto maintain the plant within safe operating envelope;\r\nto recognize and act to avoid hazardous situations;\r\nto identify deviations from desired operating conditions that could lead to financial loss;\r\nto better understand complex process conditions. Alarms should be an important diagnostic tool, and are one of several sources that an operator uses during an upset.\r\nThe terms alarm and event are often used interchangeably and their meanings are not distinct. An alarm is an abnormal condition that requires special attention. An event may or may not be associated with a condition. For example, the transitions into the level alarm condition and the return to normal are events which are associated with conditions. However, operator actions, system configuration changes, and system errors are examples of events which are not related to specific conditions.\r\nAlarm processing and handling\r\nAlarm generation means generating an alarm according to some defined rules.\r\nAlarm filtering means preventing an alarm signal so that it is not available for the operator in any part of the system.\r\nAlarm suppression means preventing an alarm from being presented in main alarm displays, e.g. overview displays, but the alarm is still available in the system at a more detailed level.\r\nAlarm shelving is a facility for manually removing an alarm from the main list and placing it on a shelve list, temporarily preventing the alarm from re-occurring on the main list until it is removed form the shelf. Shelving will normally be controlled by the operator, and is intended as a "last resort" for handling irrelevant nuisance alarms that have not been caught by signal filtering or alarm suppression mechanisms.\r\n\r\n', 'There is at least one user who is authorized to author rules for alarms, events and display.\r\nThe syntax and semantics for the concepts that are included in the Alarms&Events specification are defined and known to the development team. These concepts may include values, logic, properties, etc. to control the behavior of alarms and events. These concepts must support the customers current alarm philosophy and the relevant standards that apply for the systems customers. See AlarmLanguage_BassJohnGolden.doc for an example inspired by the Norwegian Petroleum Directorate YA-711: Principles for alarm system design, 2001 (http://www.ptil.no/regelverk/R2002/ALARM_SYSTEM_DESIGN_E.HTM).\r\nThe development team has defined presentation conventions that are salient to the user, e.g, fonts, icons, colors. These conventions must differentiate alarms, events, and messages from each other.\r\nThe protocol for saving an Alarms&Events specification is defined and known to the development team.\r\nThere is no more than one Alarms&Events specification per context of use. That is, all of the rules are bundled into one specification that the system loads when it is executed in a particular context. So, for example, there may be a single specification for normal operation of the system and a different single specification for diagnosis procedures.\r\nThe development team has decided on an appropriate protocol for concurrent users. That is, can each user be completely autonomous (e.g., being able to dismiss or suppress alarms), is one user the â€œmasterâ€ and all the rest can only observe, etc.\r\nThe development team has decided which items will be logged during execution. For example, these items might include: state transitions of an alarm, the event of failure of the alarm generation routine, the alarm generation rate,\r\n\r\n', NULL, 'Reduces impact of slips by informing the user about the deviation from normal procedure. \r\nSupports problem solving by helping user understand the problem and contributes to the solution of the problem. \r\nFacilitate learning by helping the user to understand and learn the consequences of actions \r\nAction confirmation feedback prevents the user from going any further with a mistake. The feedback acts as a gatekeeper, and need an acknowledgement to go ahead with the procedure. \r\nFeedback helps user tolerate system error by informing the user that there is a problem and possible cause of the problem. \r\nBeing able to solve a problem with help of a systemâ€™s feedback will increase user confidence by supporting the user performing his/her work. It will also build trust for the system as it always presents accurate and helpful feedback. \r\n\r\n');

-- --------------------------------------------------------